#include "cellrenderer_acl.hpp"


CellRendererACL::CellRendererACL()
	: Glib::ObjectBase (typeid(CellRendererACL)),
	Gtk::CellRendererToggle(),
	property_marca_fons_(*this, "marcar_fons", false)
{
}

void CellRendererACL::render_vfunc (const Glib::RefPtr<Gdk::Window>& window,
		Gtk::Widget& widget,
		const Gdk::Rectangle& background_area,
		const Gdk::Rectangle& cell_area,
		const Gdk::Rectangle& expose_area,
		Gtk::CellRendererState flags
		)
{
	Gtk::CellRendererToggle::render_vfunc(window, widget, background_area, cell_area, expose_area, flags);

	// Pintem una admiraci
	if (property_marca_fons_.get_value() && property_active())
	{
		Glib::RefPtr<Gtk::Style> estil = widget.get_style();
		Glib::RefPtr<Pango::Layout> pango = Pango::Layout::create(widget.get_pango_context());
		pango->set_markup("<span foreground=\"#cc0000\" weight=\"bold\">!</span>");

		Pango::Rectangle ink_rect = pango->get_pixel_ink_extents();

		// A GTK els checkboxes sempre son de 12x12 
		// per tant -> hardcode 6
		int posicioX = cell_area.get_x() + (cell_area.get_width() / 2) - 6;
		int posicioY = cell_area.get_y() + (cell_area.get_height() / 2) - 6;

		estil->paint_layout ( window,
				Gtk::STATE_NORMAL,
				false,
				cell_area,
				widget,
				"",
				posicioX - ink_rect.get_width() - 4, 
				posicioY - ink_rect.get_height() / 2,
				pango);
	}
}


Glib::PropertyProxy<bool> CellRendererACL::property_marcar_fons()
{
	return Glib::PropertyProxy<bool>(this, "marcar_fons");
}

